# Value

{% hint style="success" %}
This is the official documentation of the `forestadmin/laravel-forestadmin` v2+ and `forestadmin/symfony-forestadmin` PHP agents.
{% endhint %}

![Value Chart example](/files/4l7NnEGFDQqGYlXF4TO4)

Value Charts display a single numerical value.

They can be added to a Dashboard using the `addChart` method on the `agent` object

```php
use ForestAdmin\AgentPHP\DatasourceCustomizer\Context\AgentCustomizationContext;
use ForestAdmin\AgentPHP\DatasourceCustomizer\Decorators\Chart\ResultBuilder;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Aggregation;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\ConditionTreeFactory;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\Operators;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\Filter;

$forestAgent->addChart(
    'monthlyRecuringRevenue',
    function (AgentCustomizationContext $context, ResultBuilder $resultBuilder) {
        $aggregation = new Aggregation('Sum', 'amount');
        $filter = new Filter(
            ConditionTreeFactory::fromArray(['field' => 'status', 'operator' => Operators::EQUAL, 'value' => paid])
        );
        $value = $context->getDatasource()->getCollection('Payment')->aggregate($filter, $aggregation);

        return $resultBuilder->value($value)
    }
);

```

Or to the "Analytics" Tab of a Collection using the `addChart` method on the `collection` object

```php
use ForestAdmin\AgentPHP\DatasourceCustomizer\CollectionCustomizer;
use ForestAdmin\AgentPHP\DatasourceCustomizer\Decorators\Chart\CollectionChartContext;
use ForestAdmin\AgentPHP\DatasourceCustomizer\Decorators\Chart\ResultBuilder;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Aggregation;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\ConditionTreeFactory;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\ConditionTree\Operators;
use ForestAdmin\AgentPHP\DatasourceToolkit\Components\Query\Filters\Filter;

$forestAgent->customizeCollection('Customer', fn(CollectionCustomizer $builder) => $builder->addChart(
    'monthlyRecuringRevenue',
    function (CollectionChartContext $context, ResultBuilder $resultBuilder) {
        $aggregation = new Aggregation('Count', 'id');
        $filter = new Filter(
            ConditionTreeFactory::fromArray(
                [
                    'aggregator' => 'And',
                    'conditions' => [
                        ['field' => 'status', 'operator' => Operators::EQUAL, 'value' => 'paid']
                        ['field' => 'customer:id', 'operator' => Operators::EQUAL, 'value' => $context->getRecordId()]
                    ]
                ]
            )
        );
        $value = $context->getDatasource()->getCollection('Payment')->aggregate($filter, $aggregation);

        return $resultBuilder->value($value)
    }
);
```

Optionally, an older value can be provided to the `resultBuilder` to display a growth percentage on the top right of the widget as in the following Chart display:

![Value chart with percentage example](/files/BhB3AM8qUX1hSokZ6AP7)

```php
use ForestAdmin\AgentPHP\DatasourceCustomizer\Context\AgentCustomizationContext;
use ForestAdmin\AgentPHP\DatasourceCustomizer\Decorators\Chart\ResultBuilder;

$forestAgent->addChart(
    'appointments',
    function (AgentCustomizationContext $context, ResultBuilder $resultBuilder) {
        return $resultBuilder->value(784, 760)
    }
);
```


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.forestadmin.com/developer-guide-agents-php/agent-customization/charts/value.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
